# Measurement

Measurement endpoints provides stats data that is updated approximately every 15 minutes.

All stats requests can be made with *TOTAL*, *DAY*, or *HOUR* **granularity**.

## Request/Response Pattern[​**](#requestresponse-pattern "Copy to clipboard")

Stats endpoints have a consistent request and response pattern.

### Request Pattern[​**](#request-pattern "Copy to clipboard")

**Pattern:**

GET /v1/{PLURAL\_ENTITY\_NAME}/{ENTITY\_ID}/stats

**Example:**

GET /v1/campaigns/ff869d1f-0923-4d28-8577-4c36291f0fca/stats

### Response Pattern - TOTAL Granularity[​**](#response-pattern---total-granularity "Copy to clipboard")

> Response pattern for TOTAL Granularity requests

```
{
  "request_status": "success",
  "request_id": "57ad1ad600076e58fa35e192",
  "total_stats": [
    {
      "sub_request_status": "success",
      "total_stat": {
        "id": "7057e31f-b908-4bc7-85dd-88169f53e08d",
        "type": "CAMPAIGN",
        "granularity": "TOTAL",
        "stats": {
          "impressions": 0,
          "swipes": 0,
          "spend": 0,
          "quartile_1": 0,
          "quartile_2": 0,
          "quartile_3": 0,
          "view_completion": 0,
          "screen_time_millis": 0
        }
      }
    }
  ]
}
```

### Response Pattern - DAY Granularity[​**](#response-pattern---day-granularity "Copy to clipboard")

> Response pattern for DAY Granularity requests

```
{
  "request_status": "success",
  "request_id": "57ad240f000756e8d435a6cd",
  "timeseries_stats": [
    {
      "sub_request_status": "success",
      "timeseries_stat": {
        "id": "7057e31f-b908-4bc7-85dd-88169f53e08d",
        "type": "CAMPAIGN",
        "granularity": "DAY",
        "start_time": "2016-08-05T22:00:00.000-07:00",
        "end_time": "2016-08-07T22:00:00.000-07:00",
        "timeseries": [
          {
            "start_time": "2016-08-05T22:00:00.000-07:00",
            "end_time": "2016-08-06T22:00:00.000-07:00",
            "stats": {
              "impressions": 0,
              "swipes": 0,
              "spend": 0,
              "quartile_1": 0,
              "quartile_2": 0,
              "quartile_3": 0,
              "view_completion": 0,
              "screen_time_millis": 0
            }
          },
          {
            "start_time": "2016-08-06T22:00:00.000-07:00",
            "end_time": "2016-08-07T22:00:00.000-07:00",
            "stats": {
              "impressions": 0,
              "swipes": 0,
              "spend": 0,
              "quartile_1": 0,
              "quartile_2": 0,
              "quartile_3": 0,
              "view_completion": 0,
              "screen_time_millis": 0
            }
          }
        ]
      }
    }
  ]
}
```

Show more▼

### Response Pattern - HOUR Granularity[​**](#response-pattern---hour-granularity "Copy to clipboard")

> Response pattern for HOUR Granularity requests

```
{
  "request_status": "success",
  "request_id": "57ad245a000e3c88bc33ea4e",
  "timeseries_stats": [
    {
      "sub_request_status": "success",
      "timeseries_stat": {
        "id": "7057e31f-b908-4bc7-85dd-88169f53e08d",
        "type": "CAMPAIGN",
        "granularity": "HOUR",
        "start_time": "2016-08-05T18:00:00.000-07:00",
        "end_time": "2016-08-06T18:00:00.000-07:00",
        "timeseries": [
          {
            "start_time": "2016-08-05T18:00:00.000-07:00",
            "end_time": "2016-08-05T19:00:00.000-07:00",
            "stats": {
              "impressions": 0,
              "swipes": 0,
              "spend": 0,
              "quartile_1": 0,
              "quartile_2": 0,
              "quartile_3": 0,
              "view_completion": 0,
              "screen_time_millis": 0
            }
          },
          {
            "start_time": "2016-08-05T19:00:00.000-07:00",
            "end_time": "2016-08-05T20:00:00.000-07:00",
            "stats": {
              "impressions": 0,
              "swipes": 0,
              "spend": 0,
              "quartile_1": 0,
              "quartile_2": 0,
              "quartile_3": 0,
              "view_completion": 0,
              "screen_time_millis": 0
            }
          }
          ....
          {
            "start_time": "2016-08-06T16:00:00.000-07:00",
            "end_time": "2016-08-06T17:00:00.000-07:00",
            "stats": {
              "impressions": 0,
              "swipes": 0,
              "spend": 0,
              "quartile_1": 0,
              "quartile_2": 0,
              "quartile_3": 0,
              "view_completion": 0,
              "screen_time_millis": 0
            }
          },
          {
            "start_time": "2016-08-06T17:00:00.000-07:00",
            "end_time": "2016-08-06T18:00:00.000-07:00",
            "stats": {
              "impressions": 0,
              "swipes": 0,
              "spend": 0,
              "quartile_1": 0,
              "quartile_2": 0,
              "quartile_3": 0,
              "view_completion": 0,
              "screen_time_millis": 0
            }
          }
        ]
      }
    }
  ]
}
```

Show more▼

### Request Parameters[​**](#request-parameters "Copy to clipboard")

| Attribute                      | Description                                                                                                                                                                  | Required | Possible Values                                                                                                             |
| ------------------------------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------- | --------------------------------------------------------------------------------------------------------------------------- |
| breakdown                      | Object-level breakdown                                                                                                                                                       | O        | ad, adsquad \[Only available on Campaign Stats endpoint], campaign \[Only available on Ad Account Stats endpoint]           |
| async                          | Designates processing of report to be asynchronous                                                                                                                           | O        | true                                                                                                                        |
| async\_format                  | Designates the response format of asynchronous reporting, can be either a csv or excel file                                                                                  | O        | csv, excel                                                                                                                  |
| fields                         | Metrics requested (comma-separated)                                                                                                                                          | O        | (see table below; default: impressions,spend)                                                                               |
| end\_time                      | End Time (ISO 8601)                                                                                                                                                          | R\*      |                                                                                                                             |
| start\_time                    | Start Time (ISO 8601)                                                                                                                                                        | R\*      |                                                                                                                             |
| granularity                    | Metrics granularity                                                                                                                                                          | R        | TOTAL, DAY, HOUR, LIFETIME                                                                                                  |
| test                           | Return Sample (fake) Stats                                                                                                                                                   | O        | false (default), true                                                                                                       |
| dimension                      | Insight-level breakdown                                                                                                                                                      | O        | GEO, DEMO, INTEREST, DEVICE                                                                                                 |
| pivot                          | The pivot to be used for insights breakdown                                                                                                                                  | O        | country, region, dma, gender, age\_bucket, interest\_category\_id, interest\_category\_name, operating\_system, make, model |
| action\_report\_time           | Specifies the principle for conversion reporting                                                                                                                             | O        | conversion (default), impression\*\*                                                                                        |
| swipe\_up\_attribution\_window | Attribution window for swipe ups                                                                                                                                             | O        | 1\_DAY, 7\_DAY, 28\_DAY (default)                                                                                           |
| view\_attribution\_window      | Attribution window for views                                                                                                                                                 | O        | none, 1\_HOUR, 3\_HOUR, 6\_HOUR, 1\_DAY (default), 7\_DAY, 28\_DAY\*\*\*                                                    |
| position\_stats                | Position metric breakdown for Snap Ads within a Story Ad                                                                                                                     | O        | true                                                                                                                        |
| omit\_empty                    | Omits records with zero data for all metrics for a given date/entity. If there is data for any metric for a given date/entity, all metrics for that date/entity are returned | O        | false (default), true                                                                                                       |
| conversion\_source\_types      | Conversion source breakout by platform                                                                                                                                       | O        | web, app, offline\*\*, total, total\_off\_platform, total\_on\_platform                                                     |
| limit                          | The limit parameter specifies how many entities should be returned per page                                                                                                  | O        | integer, max 200                                                                                                            |

\* start\_time and end\_time are required for DAY and HOUR granularity and they must be set to the start of an hour (e.g. 22:00 not 22:45)<br />\*\* offline conversion data source ( **conversion\_source\_types=offline** ) and impression based conversions<br />\*\* action\_report\_time=impression\*\* ) are available from 1 May 2020 onwards<br />\*\*\* 28\_DAY view\_attribution\_window is deprecated, legacy data is available up until 1 March 2021<br />

## Response Parameters & Finalization[​**](#response-parameters--finalization "Copy to clipboard")

| Attribute                              | Description                                                                                                                                                                                                                                                                                                                                                   |
| -------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| finalized\_data\_end\_time             | This attribute defines the time up until when non-conversion reporting metrics are finalized. You can query for all metrics before this time including uniques and reach and they will have the final numbers. For any time after the finalized\_data\_end\_time the metrics are still undergoing de-duplication and finalization and may change accordingly. |
| conversion\_data\_processed\_end\_time | This attribute defines the time up until when conversion metrics are finalized, for any time after the conversion\_data\_processed\_end\_time the conversion metrics are still undergoing processing and may change accordingly. Note that this attribute only covers conversion by time of conversion.                                                       |
| paging                                 | If you are using pagination the `paging` attribute will contain a `next_link` attribute which holds the API call to fetch the next page.                                                                                                                                                                                                                      |

## Pagination[​**](#pagination "Copy to clipboard")

For calls that fetch stats for many entities we recommend that you use pagination. The limit parameter specifies how many entities should be returned per page. The maximum pagination limit is 200.

The returned result will contain a `paging` attribute, this in turn holds a `next_link` attribute which holds the API call to fetch the next page. Paginated calls are rdered by time of creation, non-paginated calls are unsorted.

## Request size limits for large requests[​**](#request-size-limits-for-large-requests "Copy to clipboard")

Synchronous stats responses are size-limited. If the response to a synchronous `GET /v1/{entity}/{id}/stats` request would be too large, the request is rejected with an HTTP `400 Bad Request` and error code `E9001`:

```
{
  "request_status": "ERROR",
  "error_code": "E9001",
  "display_message": "Stats response is too large to process. Reduce the request size by using fewer fields or a shorter date range."
}
```

This is a **client error**, not a transient server error — it will not succeed on retry. To get the data you need, you must reduce the size of the request or move it to [asynchronous reporting](#asynchronous-reporting-requests).

Response size grows with the number of **entities** (breakdown fan-out) × **fields** × **time intervals**. Broad breakdown queries (for example, ad-account or campaign level across many metrics over a multi-day range) are the most likely to exceed the limit.

To stay within the synchronous size limit:

* **For large reports, use [asynchronous reporting](#asynchronous-reporting-requests) (`async=true`).** Async reports return a downloadable CSV or Excel file and are **not** subject to the synchronous response-size limit. This is the recommended path for any large pull.
* Request **fewer `fields`**.
* Use a **shorter date range** and/or a **coarser `granularity`** (`TOTAL` or `DAY` rather than `HOUR`).
* Set **`omit_empty=true`** to drop records that have zero data for all metrics.
* For many-entity breakdowns, [paginate](#pagination) with `limit` ≤ 200 entities per page.

Very large synchronous responses are rejected — there is no fixed byte limit you can rely on. If you hit `E9001`, reduce the request as described above, or switch to asynchronous reporting for large pulls.

## Core Metrics[​**](#core-metrics "Copy to clipboard")

The following metrics are available for all Snap Ads.

| Field Name           | Description                                                                                                                                                       |
| -------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| impressions          | Impression Count                                                                                                                                                  |
| swipes               | Swipe-Up Count                                                                                                                                                    |
| view\_time\_millis   | Use screen\_time\_millis instead. Total Time Spent on top Snap Ad (milliseconds)                                                                                  |
| screen\_time\_millis | Total Time Spent on top Snap Ad (milliseconds)                                                                                                                    |
| quartile\_1          | Video Views to 25%                                                                                                                                                |
| quartile\_2          | Video Views to 50%                                                                                                                                                |
| quartile\_3          | Video Views to 75%                                                                                                                                                |
| view\_completion     | Video Views to completion                                                                                                                                         |
| spend                | Amount Spent (micro-currency)                                                                                                                                     |
| coupon\_used\_local  | Amount Spent via Coupon in the assigned currency of Ad Account (micro-currency)                                                                                   |
| coupon\_used\_usd    | Amount Spent via Coupon in USD (micro-currency)                                                                                                                   |
| video\_views         | The total number of impressions that meet the qualifying video view criteria of at least 2 seconds of consecutive watch time or a swipe up action on the Top Snap |

Micro-currency conversion: 1.00 local currency unit = 1000000 Micro-currency. See [Monetary Values](#monetary-values) for details.

IMPORTANT: Metrics are finalized 48 hours after the end of the day in the timezone set by the Ad Account .

## Asynchronous reporting requests[​**](#asynchronous-reporting-requests "Copy to clipboard")

Large reporting requests may time out or return errors, these requests are suitable to be executed using the asynchronous mode. The format of an asynchronous report can be defined either as a comma separated file (CSV) or an Excel spreadsheet. Async reports are not subject to the synchronous [request size limit](#request-size-limits-for-large-requests), so they are the recommended path for large or broad breakdown queries.

Requests marked as asynchronous will produce a `report_run_id` which is needed to check the status of a report, and to retrieve a report, once a report is ready the response body will contain a download url for the finished report. The download url will be valid for seven days, after this the report will be unavailable.

### Generating an async report[​**](#generating-an-async-report "Copy to clipboard")

The first step to generate an asynchronous report is the creation, this request needs to include the `async` parameter.

### HTTP Requests[​**](#http-requests "Copy to clipboard")

`GET https://adsapi.snapchat.com/v1/adaccounts/{ad_account_id}/stats`<br />`GET https://adsapi.snapchat.com/v1/campaigns/{campaign_id}/stats`<br />`GET https://adsapi.snapchat.com/v1/adsquads/{adsquad_id}/stats`<br />`GET https://adsapi.snapchat.com/v1/ads/{ad_id}/stats`<br />

#### Parameters for creating an asynchronous report[​**](#parameters-for-creating-an-asynchronous-report "Copy to clipboard")

The below listed parameters are specific for asynchronous reporting, aside from these parameters all [request parameters](/marketing-api/Ads-API/measurement.md#request-parameters) are supported, including `granularity` (see the [Request Parameters](#request-parameters) table above for the full set of supported values). The asynchronous creation will return a `report_run_id` which is needed to fetch the report.

Asynchronous requests share the same request parameters as synchronous requests, but do **not** enforce the per-granularity time-window caps that synchronous requests do — for example, the 7-day interval limit on HOUR queries. Async is built for bulk extracts and intentionally allows longer windows. The following still apply to async requests:

* Hour alignment on `start_time` / `end_time` (must fall on the start of an hour), and the earliest queryable date of 2013-01-01.
* When the DAY granularity is used `start_time` and `end_time` are required values, the `start_time` and `end_time` must be the daily boundry for the timezone of the Ad Account in question
* When `start_time` and `end_time` is not defined in combination with granularity TOTAL it is treated the same as granularity LIFETIME

| Parameter     | Description                                                                                 | Required | Possible values      |
| ------------- | ------------------------------------------------------------------------------------------- | -------- | -------------------- |
| async         | Designates processing of report to be asynchronous                                          | R        | true                 |
| async\_format | Designates the response format of asynchronous reporting, can be either a csv or excel file | O        | csv (default), excel |

#### HOUR granularity caveats[​**](#hour-granularity-caveats "Copy to clipboard")

`granularity=HOUR` is supported for asynchronous requests, with the same field and breakdown eligibility rules as synchronous requests:

* **HOUR cannot be combined with Delivery Insights** (`dimension` / `pivot` / `report_dimension`).
* **Not eligible at HOUR:** `conversion_visit*` metrics, and reach/uniques metrics (`uniques`, `frequency`, `total_reach`, `earned_reach`, `attachment_uniques`, `attachment_frequency`). Use `DAY`, `TOTAL`, or `LIFETIME` instead.
* Hourly pulls are up to a 24x row multiplier versus daily — prefer `async_format=csv` over `excel`, which caps near 1,048,576 rows.

#### Example - Step 1 Generating an async report[​**](#example---step-1-generating-an-async-report "Copy to clipboard")

This request produces a `report_run_id` and the `async_status` returned is STARTED.

```
curl "https://adsapi.snapchat.com/v1/adaccounts/ce943c3b-2404-4fff-acb1-259b7b052f27/stats?breakdown=ad&granularity=DAY&view_attribution_window=1_DAY&async=true&omit_empty=true&fields=impressions,total_installs,spend,swipes,attachment_video_views,story_opens,story_completes,shares,saves,conversion_purchases,conversion_purchases_value,conversion_save,conversion_start_checkout,conversion_add_cart,conversion_view_content,conversion_add_billing,conversion_sign_ups,conversion_searches,conversion_level_completes,conversion_app_opens,conversion_page_views&start_time=2024-10-01T00:00:00&end_time=2024-10-08T00:00:00&swipe_up_attribution_window=28_DAY" \
  -H "Authorization: Bearer meowmeowmeow"
```

> The above command returns JSON structured like this:

```
{
  "request_status": "SUCCESS",
  "request_id": "acfacd19-bd51-4822-a9d3-e503a523d25f",
  "async_stats_reports": [
    {
      "sub_request_status": "SUCCESS",
      "async_stats_report": {
        "report_run_id": "ASYNC_STATS:ce943c3b-2404-4fff-acb1-259b7b052f27:1727755200000:7245f6e6-eda4-4650-9255-6e3ab38b95ce",
        "async_status": "STARTED"
      }
    }
  ]
}
```

### Checking the status of an asynchronous report[​**](#checking-the-status-of-an-asynchronous-report "Copy to clipboard")

The second step of asynchronus reporting is checking the status of the report and fetching the download url of the finished report, this request requires the `report_run_id` value returned in the previous request.

### HTTP Requests[​**](#http-requests-1 "Copy to clipboard")

`GET https://adsapi.snapchat.com/v1/adaccounts/{ad_account_id}/stats_report`<br />`GET https://adsapi.snapchat.com/v1/campaigns/{campaign_id}/stats_report`<br />`GET https://adsapi.snapchat.com/v1/adsquads/{adsquad_id}/stats_report`<br />`GET https://adsapi.snapchat.com/v1/ads/{ad_id}/stats_report`<br />

#### Parameters for checking asynchronous reporting[​**](#parameters-for-checking-asynchronous-reporting "Copy to clipboard")

When checking asynchronous reporting requests the

| Parameter       | Description                        | Required | Possible values |
| --------------- | ---------------------------------- | -------- | --------------- |
| report\_run\_id | The id of the report to be fetched | R        |                 |

#### Example - Step 2 Checking the status of an async report - Report is processing[​**](#example---step-2-checking-the-status-of-an-async-report---report-is-processing "Copy to clipboard")

This request requires the `report_run_id` and the `async_status` returned is RUNNING which indicates that the report is still processing.

```
curl "https://adsapi.snapchat.com/v1/adaccounts/ce943c3b-2404-4fff-acb1-259b7b052f27/stats_report?report_run_id=ASYNC_STATS:6b78bf3c-b7f4-4fcf-b74a-a5aaa91b15ef:1726804800000:7139d12c-910e-4e09-b3fd-a01f82b3af56" \
  -H "Authorization: Bearer meowmeowmeow"
```

> The above command returns JSON structured like this:

```
{
  "request_status": "SUCCESS",
  "request_id": "f8a5b7b0-14b4-950c-934f-7b746745e571",
  "async_stats_reports": [
    {
      "sub_request_status": "SUCCESS",
      "async_stats_report": {
        "report_run_id": "ASYNC_STATS:6b78bf3c-b7f4-4fcf-b74a-a5aaa91b15ef:1726804800000:7139d12c-910e-4e09-b3fd-a01f82b3af56",
        "async_status": "RUNNING"
      }
    }
  ]
}
```

#### Example - Step 2 Checking the status of an async report - Report is completed[​**](#example---step-2-checking-the-status-of-an-async-report---report-is-completed "Copy to clipboard")

This request requires the `report_run_id` and the `async_status` returned is COMPLETED, the url of the report is found in the `result` attribute.

```
curl "https://adsapi.snapchat.com/v1/adaccounts/ce943c3b-2404-4fff-acb1-259b7b052f27/stats_report?report_run_id=ASYNC_STATS:6b78bf3c-b7f4-4fcf-b74a-a5aaa91b15ef:1726804800000:7139d12c-910e-4e09-b3fd-a01f82b3af56" \
  -H "Authorization: Bearer meowmeowmeow"
```

> The above command returns JSON structured like this:

```
{
  "request_status": "SUCCESS",
  "request_id": "f8a5b7b0-14b4-950c-934f-7b746745e571",
  "async_stats_reports": [
    {
      "sub_request_status": "SUCCESS",
      "async_stats_report": {
        "report_run_id": "ASYNC_STATS:6b78bf3c-b7f4-4fcf-b74a-a5aaa91b15ef:1726804800000:7139d12c-910e-4e09-b3fd-a01f82b3af56",
        "async_status": "COMPLETED",
        "result": "https://data-transfer.snapads.com/async-report/snap_ads/ASYNC_STATS:6b78bf3c-b7f4-4fcf-b74a-a5aaa91b15ef:1726804800000:7139d12c-990e-4e09-b3fd-a01f82b3af56/9496dff0-07b9-44d8-8f0b-b44eb276cc9e.xlsx"
      }
    }
  ]
}
```

### Reach Overlap Reporting[​**](#reach-overlap-reporting "Copy to clipboard")

Reach overlap reporting via async reporting is available for Campaigns, Ad Squads and Ads using the Snapchat Marketing API.

Reach values are estimates.

The entities for which the calculation is made must belong to the same Ad Account, overlap reporting across different Ad Accounts is not possible. If an entity has no metrics for the given reporting period (start\_time / end\_time), it will be excluded from the resulting report.

### HTTP Request[​**](#http-request "Copy to clipboard")

`GET https://adsapi.snapchat.com/v1/adaccounts/{ad_account_id}/stats?overlap=true&overlap_type={campaign/ad_squad/ad}&ids={entity1_id,entity_id,...},{entity2_id}&start_time={start_time}&end_time={end_time}&async_format={csv/excel}`<br />

#### Request Parameters[​**](#request-parameters-1 "Copy to clipboard")

| Attribute     | Description                                                                                                                                                  | Possible values                                                          |
| ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------ |
| async\_format | Defines the returned format of the report                                                                                                                    | csv,excel                                                                |
| ids           | Two or more Campaign/Ad Squad/Ad entities to calculate the reach overlap for, these have to be the same type of entities and live within the same Ad Account | Comma separated string of up to 100 Campaign ID/Ad Squad ID/Ad ID values |
| overlap       | Indicates whether an overlap calculation should take place                                                                                                   | true                                                                     |
| overlap\_type | Specifies the entity level of the overlap calculation, you cannot use two different types of entities in one report                                          | campaign, ad\_squad, ad                                                  |
| start\_time   | Start time of the report                                                                                                                                     | Start time in ISO format                                                 |
| end\_time     | End time of the report                                                                                                                                       | End time in ISO format                                                   |

#### Example Request[​**](#example-request "Copy to clipboard")

This request generates an async process to create an overlap report in Excel format for two Campaigns in the same Ad Account, for the time period 1-30 April 2024.

```
curl 'https://adsapi.snapchat.com/v1/adaccounts/62f51caa-394c-4f88-905c-71a9859f2b54/stats?overlap=true&overlap_type=campaign&ids=11f5bc01-22a4-469e-ba7e-d4c7edc5ef88%2C50984a9d-1b2e-4d5d-857e-5ac9d3665506%2C54f10e2d-55a8-4924-896d-5a94fba1a0c9&start_time=2024-04-01T07%3A00%3A00.000Z&end_time=2024-04-30T07%3A00%3A00.000Z&async_format=excel' \
-H "Authorization: Bearer meowmeowmeow"
```

#### Response[​**](#response "Copy to clipboard")

```
{
  "request_status": "SUCCESS",
  "request_id": "f5cdc549-f3f3-4aed-9e39-68216ba70be3",
  "async_stats_reports": [
    {
      "sub_request_status": "SUCCESS",
      "async_stats_report": {
        "report_run_id": "ASYNC_STATS:62f51caa-394c-4f88-905c-71a9859f2b54:1711954800000:f591f1c1-581e-477b-892f-7b8b5365b0e7",
        "async_status": "STARTED"
      }
    }
  ]
}
```

Once the async process for an overlap report is initiated using the above request, follow the steps in [Checking the status of an asynchronous report](/marketing-api/Ads-API/measurement.md#checking-the-status-of-an-asynchronous-report) to check the status and fetch the download url of a completed report.

### Report Format[​**](#report-format "Copy to clipboard")

Below is an example of a `Reach Overlap` report downloaded in excel format. This resulting report includes metrics for `reach` and `uniques`, showing the overlap for the requested entities. The requested entities in this example are two campaigns - Wellness Campaign and Beauty Campaign.

The report starts with `Reached by all`, which is the `Reach Overlap` for all the entities that were included in the report.

#### Example[​**](#example "Copy to clipboard")

* `Row 1` shows the `Reach Overlap` for all the Campaigns in the report.

The report also accounts for the `Total Uniques` for all the entities in the report.

#### Example[​**](#example-1 "Copy to clipboard")

* `Row 2` shows the `Total Uniques` reached by all campaigns in the report.

If `Campaign Id 1` and `Campaign Id 2` are the same, it means the metric is just for that campaign.

#### Example[​**](#example-2 "Copy to clipboard")

* `Row 4` below shows the total `Reach` of the Wellness Campaign
* `Row 6` below shows the total `Uniques` of the Wellness Campaign
* `Row 7` below shows the total `Reach` of the Beauty Campaign
* `Row 9` below shows the total `Uniques` of the Beauty Campaign

If `Campaign Id 1` and `Campaign Id 2` are different it shows an overlap calculation between the two campaigns.

#### Example[​**](#example-3 "Copy to clipboard")

* `Row 5` and `Row 8` shows the `Reach Overlap` of the Wellness Campaign and the Beauty Campaign.

|   | A                                   | B                 | C                                   | D                 | E          | F           |
| - | ----------------------------------- | ----------------- | ----------------------------------- | ----------------- | ---------- | ----------- |
| 1 | Reached by all                      | 6,029             |                                     |                   |            |             |
| 2 | Total Uniques Reached               | 212,351           |                                     |                   |            |             |
| 3 | Campaign Id 1                       | Campaign Name 1   | Campaign Id 2                       | Campaign Name 2   | Reach Type | Reach Value |
| 4 | 11111111-1111-1111-111111111111     | Wellness Campaign | 11111111-1111-1111-111111111111     | Wellness Campaign | Total      | 160.356     |
| 5 | 11111111-1111-1111-111111111111     | Wellness Campaign | 222222222-2222-2222-2222-2222222222 | Beauty Campaign   | Overlap    | 6,029       |
| 6 | 11111111-1111-1111-111111111111     | Wellness Campaign | 11111111-1111-1111-111111111111     | Wellness Campaign | Unique     | 154,327     |
| 7 | 222222222-2222-2222-2222-2222222222 | Beauty Campaign   | 222222222-2222-2222-2222-2222222222 | Beauty Campaign   | Total      | 60,746      |
| 8 | 222222222-2222-2222-2222-2222222222 | Beauty Campaign   | 11111111-1111-1111-111111111111     | Wellness Campaign | Overlap    | 6,029       |
| 9 | 222222222-2222-2222-2222-2222222222 | Beauty Campaign   | 222222222-2222-2222-2222-2222222222 | Beauty Campaign   | Unique     | 54,717      |

## Additional Metrics[​**](#additional-metrics "Copy to clipboard")

See the [Metrics and supported granularities](/marketing-api/Ads-API/measurement.md#metrics-and-supported-granularities) table for a breakdown of the reporting granularities available per Ad type. For LIFETIME granularity the data is only accessible as finalized data, available after 48-72 hours.

| Field Name                            | Snap Ad Types              | Description                                                                                                                                                                                                 |
| ------------------------------------- | -------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| android\_installs                     | APP\_INSTALL               | # of Android App Installs                                                                                                                                                                                   |
| attachment\_avg\_view\_time\_millis   | Any Attachment             | Average Attachment View Time (milli-seconds)                                                                                                                                                                |
| attachment\_frequency                 | Any Attachment             | Average # of Attachment Views per User Reached                                                                                                                                                              |
| attachment\_quartile\_1               | LONGFORM\_VIDEO            | Long Form Video Views to 25%                                                                                                                                                                                |
| attachment\_quartile\_2               | LONGFORM\_VIDEO            | Long Form Video Views to 50%                                                                                                                                                                                |
| attachment\_quartile\_3               | LONGFORM\_VIDEO            | Long Form Video Views to 75%                                                                                                                                                                                |
| attachment\_total\_view\_time\_millis | Any Attachment             | Total Attachment View Time (milli-seconds)                                                                                                                                                                  |
| attachment\_uniques                   | Any Attachment             | # of unique attachment impressions                                                                                                                                                                          |
| attachment\_view\_completion          | LONGFORM\_VIDEO            | Long Form Video Views to completion                                                                                                                                                                         |
| attachment\_video\_views              | LONGFORM\_VIDEO            | Long Form Video Attachment Views, viewed for at least 10 consecutive seconds or reached 97% of the Long Form Video duration                                                                                 |
| avg\_view\_time\_millis               | Any                        | Use avg\_screen\_time\_millis instead. Average Top Snap view time per User Reached                                                                                                                          |
| avg\_screen\_time\_millis             | Any                        | Average Top Snap view time across all impressions                                                                                                                                                           |
| frequency                             | Any                        | Average # of Impressions per User Reached                                                                                                                                                                   |
| ios\_installs                         | APP\_INSTALL               | # of iOS App Installs                                                                                                                                                                                       |
| swipe\_up\_percent                    | Any Attachment             | % of Impressions that Swiped-Up                                                                                                                                                                             |
| total\_installs                       | APP\_INSTALL               | Total # of App Installs                                                                                                                                                                                     |
| uniques                               | Any                        | # of unique impressions                                                                                                                                                                                     |
| video\_views\_time\_based             | Any                        | The total number of impressions that meet the qualifying video view criteria of at least 2 seconds, not including swipe ups                                                                                 |
| video\_views\_5s\*\*                  | Any                        | The total number of impressions that meet the qualifying video view criteria of at least 5 seconds, or a swipe up action on the ad                                                                          |
| video\_views\_15s                     | Any                        | The total number of impressions that meet the qualifying video view criteria of at least 15 seconds, or 97% completion if it's shorter than 15 seconds, or a swipe up action on the ad                      |
| engaged\_views                        | Any                        | The total number of times Snapchatters viewed your video ad for five seconds or longer                                                                                                                      |
| story\_opens                          | STORY                      | # of times users tapped on the ad tile in the feed to view the Story Ad                                                                                                                                     |
| story\_completes                      | STORY                      | # of times users viewed through to the last Snap of your Story Ad                                                                                                                                           |
| landing\_page\_views                  |                            | # of times a Snapchatter has loaded the ad’s landing page after a click page                                                                                                                                |
| profile\_clicks                       | Any                        | # of times users tapped the logo in the upper corner taking them to the profile page                                                                                                                        |
| poll\_sticker\_voted                  | Any with a poll sticker    | Number of votes submitted on a [poll sticker](/marketing-api/Ads-API/stickers.md#poll-sticker). Request this metric in the `fields` query parameter.                                                        |
| position\_impressions                 | STORY                      | # the impression number for this story ad position                                                                                                                                                          |
| position\_screen\_time\_millis        | STORY                      | # the total view time in milliseconds for this story ad position                                                                                                                                            |
| position\_swipe\_up\_percent          | STORY                      | # the swipe up rate for this story ad position                                                                                                                                                              |
| avg\_position\_screen\_time\_millis   | STORY                      | # the average view time for this story ad position                                                                                                                                                          |
| shares                                | LENS, AD\_TO\_LENS, FILTER | # of times lens/filter was shared in a Chat or Story                                                                                                                                                        |
| saves                                 | LENS, AD\_TO\_LENS, FILTER | # of times lens/filter was saved to Memories                                                                                                                                                                |
| paid\_impressions                     | LENS, FILTER, AD\_TO\_LENS | The total number of times your ad was served to a Snapchatter. Tracked when the ad fully renders on a device for the first time during a Snapchatter’s viewing session                                      |
| earned\_impressions                   | LENS, FILTER, AD\_TO\_LENS | The number of times your ad was viewed after being shared by a Snapchatter via Chat or Stories                                                                                                              |
| total\_impressions                    | LENS                       | The total number of impressions (Paid and Earned)                                                                                                                                                           |
| play\_time\_millis                    | LENS                       | The total amount of time in where Snapchatters interacted with your Lens in the camera (milliseconds)                                                                                                       |
| total\_reach                          | LENS                       | The estimated number of unique Snapchatters who viewed your Lens ad, either by receiving a Paid or Earned Impression.                                                                                       |
| earned\_reach                         | LENS, FILTER, AD\_TO\_LENS | The estimated number of unique Snapchatters who viewed the filter/lens after being shared by a Snapchatter via Chat or Stories                                                                              |
| native\_leads                         | LEAD\_GENERATION           | Total number of Snapchat users that swipe up, fill out the required fields, and hit ‘Submit’ on Lead Form attachments. If a user swipes down or cancels before hitting 'Submit,' this action is not counted |
| reminders\_set                        | REMINDER                   | Total number of clicks on the CTA when attachment is Reminder                                                                                                                                               |
| place\_opens                          | AD\_TO\_PLACE              | Total number of taps or clicks into the Promoted Place Profile                                                                                                                                              |
| place\_actions                        | AD\_TO\_PLACE              | Total number of actions taken inside the Place Profile, including tapping for directions, calling the business, or viewing the business profile                                                             |

\*engaged\_views are available from 10 February 2025 onwards

\*\*video\_views\_5s are available from 11 March 2025 onwards

Micro-currency conversion: 1.00 local currency unit = 1000000 Micro-currency. See [Monetary Values](#monetary-values) for details.

## Apple Transparent Tracking (ATT) Reporting[​**](#apple-transparent-tracking-att-reporting "Copy to clipboard")

All the users whose activity is tracked using the attribution and measurement services will be split into two categories. Please note that only [conversion metrics](#conversion-event-stats) are affected by the ATT updates.

| User Category               | Description                                                          | User groups in category                                                |
| --------------------------- | -------------------------------------------------------------------- | ---------------------------------------------------------------------- |
| **Fully Tracked group**     | These user groups are fully supported for the features listed below. | Android, iOS opted-in users                                            |
| **Partially tracked group** | These user groups are partially supported.                           | Snap Pixel, iOS opted out users and users reported via Conversions API |

Below is the list of all the reporting fields and API fields that are affected for each group.

| Dimension/Granularity                                                                    | Conversion Sources                                            |                                                                              |
| ---------------------------------------------------------------------------------------- | ------------------------------------------------------------- | ---------------------------------------------------------------------------- |
|                                                                                          | **Fully Tracked Group** -<br />Android (in-app), iOS (opt-in) | **Partially tracked Group** -<br />Snap Pixel, iOS (opt-out), Conversion API |
| Time of Conversion<br />action\_report\_time=conversion                                  | Supported                                                     | Supported                                                                    |
| Time of Exposure<br />action\_report\_time=impression                                    | Supported                                                     | Supported                                                                    |
| Event Source<br />(web/app/offline)                                                      | Supported                                                     | Supported                                                                    |
| Entity<br />(campaign/ad set/ad)                                                         | Supported                                                     | Supported                                                                    |
| Age                                                                                      | Supported                                                     | Supported                                                                    |
| Gender                                                                                   | Supported                                                     | Supported                                                                    |
| Age, Gender                                                                              | Supported                                                     | Supported                                                                    |
| Country                                                                                  | Supported                                                     | Supported                                                                    |
| OS                                                                                       | Supported                                                     | Supported                                                                    |
| Platform (on/off snapchat)                                                               | Supported                                                     | Supported                                                                    |
| Region (US Only)                                                                         | Supported                                                     | **NOT Supported**                                                            |
| DMA (US Only)                                                                            | Supported                                                     | **NOT Supported**                                                            |
| Device Make                                                                              | Supported                                                     | **NOT Supported**                                                            |
| SLC (lifestyle category)                                                                 | Supported                                                     | **NOT Supported**                                                            |
| Product                                                                                  | Supported                                                     | **NOT Supported**                                                            |
| Hourly Conversions                                                                       | Supported                                                     | **NOT Supported**                                                            |
| Daily, Total, Lifetime Conversion                                                        | Supported                                                     | Supported                                                                    |
| Swipe Up Window:<br />1\_DAY, 7\_DAY, 28\_DAY<br />View Thru Window:<br />1\_DAY, 7\_DAY | Supported                                                     | Supported                                                                    |
| View Through Window:<br />1\_HOUR, 3\_HOUR, 6\_HOUR                                      | Supported                                                     | Supported                                                                    |
| View Through Window: 28\_DAY\*                                                           | **NOT Supported**                                             | **NOT Supported**                                                            |

Please Note:

* The View Through Window value of 28\_DAY is now effectively deprecated.

* Any legacy data for these users will continue to be returned.

\*This field is now effectively deprecated.

## SKAd Network Reporting[​**](#skad-network-reporting "Copy to clipboard")

Due to the attribution methodology of Apple’s SKAdNetwork there are some limitations when fetching reporting for Ad serving entities that are opted into SKAdNetwork tracking.

* SKAdNetwork conversions reported at the Ad level or below may be modeled based on first party ad engagement signals using statistical methods. Modeling is only applied at the ad level. Please note that you should still take a patient approach to testing and optimization decisions including: waiting 48+ hours before adjusting Bids and Budgets, and starting with high Bids and Budgets to pass privacy thresholds. If you do not, you run the risk of prematurely pausing Ad creatives that may lead to strong performance.

* The available granularities are DAY, TOTAL, and LIFETIME, HOUR granularity is **not** available.

* The conversion window for a SKAd Network SWIPE (click) conversion is 30 day based on the time of conversion, all ad types support SWIPE conversions.

* The conversion window for a SKAd Network VIEW conversion is 24 hours based on the time of conversion. A VIEW is defined as 3 seconds in length.

* The ad types that currently support the VIEW conversion are; SNAP\_AD, LONGFORM\_VIDEO, APP\_INSTALL, REMOTE\_WEBPAGE, DEEP\_LINK, COLLECTION

* Reporting Insights are not available for SKAdNetwork metrics, the use of `report_dimension` is not possible.

## SKAd Network Conversion Metrics[​**](#skad-network-conversion-metrics "Copy to clipboard")

Conversion metrics for the SKAd Network are broken out by Swipe conversions, View conversions, and the total number of conversions.

### SKAd Network Swipe Conversion Metrics[​**](#skad-network-swipe-conversion-metrics "Copy to clipboard")

The following metrics return the SKAd Network SWIPE (click) conversions.

| Name                                               | Description                                                                                                                                                                                     |
| -------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| conversion\_total\_installs\_sk\_ad\_network       | Total App Installs tracked via SKAd Network                                                                                                                                                     |
| conversion\_ios\_installs\_sk\_ad\_network         | Exact same metric as conversion\_total\_installs\_sk\_ad\_network                                                                                                                               |
| conversion\_purchases\_sk\_ad\_network             |                                                                                                                                                                                                 |
| conversion\_save\_sk\_ad\_network                  |                                                                                                                                                                                                 |
| conversion\_start\_checkout\_sk\_ad\_network       |                                                                                                                                                                                                 |
| conversion\_add\_cart\_sk\_ad\_network             |                                                                                                                                                                                                 |
| conversion\_view\_content\_sk\_ad\_network         |                                                                                                                                                                                                 |
| conversion\_add\_billing\_sk\_ad\_network          |                                                                                                                                                                                                 |
| conversion\_sign\_ups\_sk\_ad\_network             |                                                                                                                                                                                                 |
| conversion\_searches\_sk\_ad\_network              |                                                                                                                                                                                                 |
| conversion\_level\_completes\_sk\_ad\_network      |                                                                                                                                                                                                 |
| conversion\_app\_opens\_sk\_ad\_network            |                                                                                                                                                                                                 |
| conversion\_page\_views\_sk\_ad\_network           |                                                                                                                                                                                                 |
| conversion\_subscribe\_sk\_ad\_network             |                                                                                                                                                                                                 |
| conversion\_ad\_click\_sk\_ad\_network             |                                                                                                                                                                                                 |
| conversion\_ad\_view\_sk\_ad\_network              |                                                                                                                                                                                                 |
| conversion\_complete\_tutorial\_sk\_ad\_network    |                                                                                                                                                                                                 |
| conversion\_invite\_sk\_ad\_network                |                                                                                                                                                                                                 |
| conversion\_login\_sk\_ad\_network                 |                                                                                                                                                                                                 |
| conversion\_share\_sk\_ad\_network                 |                                                                                                                                                                                                 |
| conversion\_reserve\_sk\_ad\_network               |                                                                                                                                                                                                 |
| conversion\_achievement\_unlocked\_sk\_ad\_network |                                                                                                                                                                                                 |
| conversion\_add\_to\_wishlist\_sk\_ad\_network     |                                                                                                                                                                                                 |
| conversion\_spend\_credits\_sk\_ad\_network        |                                                                                                                                                                                                 |
| conversion\_rate\_sk\_ad\_network                  |                                                                                                                                                                                                 |
| conversion\_start\_trial\_sk\_ad\_network          |                                                                                                                                                                                                 |
| conversion\_list\_view\_sk\_ad\_network            |                                                                                                                                                                                                 |
| conversion\_visitation\_sk\_ad\_network            |                                                                                                                                                                                                 |
| custom\_event\_1\_sk\_ad\_network                  |                                                                                                                                                                                                 |
| custom\_event\_2\_sk\_ad\_network                  |                                                                                                                                                                                                 |
| custom\_event\_3\_sk\_ad\_network                  |                                                                                                                                                                                                 |
| custom\_event\_4\_sk\_ad\_network                  |                                                                                                                                                                                                 |
| custom\_event\_5\_sk\_ad\_network                  |                                                                                                                                                                                                 |
| unknown\_sk\_ad\_network                           | SkAdNetwork conversion events with unknown Conversion Values                                                                                                                                    |
| conversion\_assist\_install\_sk\_ad\_network       | The number of times the SKAdNetwork campaign drove an App Install, but was not the last touch before the App Install occurred. conversion\_null\_sk\_ad\_network                                |
| conversion\_null\_sk\_ad\_network                  | The number of SKAdNetwork conversion events with "null" Conversion Values. This indicates the campaign did not generate enough daily SKAdNetwork conversions to pass Apple’s privacy threshold. |

### SKAd Network View Conversion Metrics[​**](#skad-network-view-conversion-metrics "Copy to clipboard")

The following metrics return the SKAd Network VIEW conversions.

| Name                                                     | Description                                                                                                                                                                                    |
| -------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| conversion\_total\_installs\_sk\_ad\_network\_view       | Total App Installs tracked via SKAd Network                                                                                                                                                    |
| conversion\_ios\_installs\_sk\_ad\_network\_view         | Exact same metric as conversion\_total\_installs\_sk\_ad\_network\_view                                                                                                                        |
| conversion\_purchases\_sk\_ad\_network\_view             |                                                                                                                                                                                                |
| conversion\_save\_sk\_ad\_network\_view                  |                                                                                                                                                                                                |
| conversion\_start\_checkout\_sk\_ad\_network\_view       |                                                                                                                                                                                                |
| conversion\_add\_cart\_sk\_ad\_network\_view             |                                                                                                                                                                                                |
| conversion\_view\_content\_sk\_ad\_network\_view         |                                                                                                                                                                                                |
| conversion\_add\_billing\_sk\_ad\_network\_view          |                                                                                                                                                                                                |
| conversion\_sign\_ups\_sk\_ad\_network\_view             |                                                                                                                                                                                                |
| conversion\_searches\_sk\_ad\_network\_view              |                                                                                                                                                                                                |
| conversion\_level\_completes\_sk\_ad\_network\_view      |                                                                                                                                                                                                |
| conversion\_app\_opens\_sk\_ad\_network\_view            |                                                                                                                                                                                                |
| conversion\_page\_views\_sk\_ad\_network\_view           |                                                                                                                                                                                                |
| conversion\_subscribe\_sk\_ad\_network\_view             |                                                                                                                                                                                                |
| conversion\_ad\_click\_sk\_ad\_network\_view             |                                                                                                                                                                                                |
| conversion\_ad\_view\_sk\_ad\_network\_view              |                                                                                                                                                                                                |
| conversion\_complete\_tutorial\_sk\_ad\_network\_view    |                                                                                                                                                                                                |
| conversion\_invite\_sk\_ad\_network\_view                |                                                                                                                                                                                                |
| conversion\_login\_sk\_ad\_network\_view                 |                                                                                                                                                                                                |
| conversion\_share\_sk\_ad\_network\_view                 |                                                                                                                                                                                                |
| conversion\_reserve\_sk\_ad\_network\_view               |                                                                                                                                                                                                |
| conversion\_achievement\_unlocked\_sk\_ad\_network\_view |                                                                                                                                                                                                |
| conversion\_add\_to\_wishlist\_sk\_ad\_network\_view     |                                                                                                                                                                                                |
| conversion\_spend\_credits\_sk\_ad\_network\_view        |                                                                                                                                                                                                |
| conversion\_rate\_sk\_ad\_network\_view                  |                                                                                                                                                                                                |
| conversion\_start\_trial\_sk\_ad\_network\_view          |                                                                                                                                                                                                |
| conversion\_list\_view\_sk\_ad\_network\_view            |                                                                                                                                                                                                |
| conversion\_visitation\_sk\_ad\_network\_view            |                                                                                                                                                                                                |
| custom\_event\_1\_sk\_ad\_network\_view                  |                                                                                                                                                                                                |
| custom\_event\_2\_sk\_ad\_network\_view                  |                                                                                                                                                                                                |
| custom\_event\_3\_sk\_ad\_network\_view                  |                                                                                                                                                                                                |
| custom\_event\_4\_sk\_ad\_network\_view                  |                                                                                                                                                                                                |
| custom\_event\_5\_sk\_ad\_network\_view                  |                                                                                                                                                                                                |
| unknown\_sk\_ad\_network\_view                           | SkAdNetwork conversion events with unknown Conversion Values                                                                                                                                   |
| conversion\_assist\_install\_sk\_ad\_network\_view       | The number of times the SKAdNetwork campaign drove an App Install, but was not the last touch before the App Install occurred                                                                  |
| conversion\_null\_sk\_ad\_network\_view                  | The number of SKAdNetwork conversion events with "null" Conversion Values. This indicates the campaign did not generate enough daily SKAdNetwork conversions to pass Apple’s privacy threshold |

### SKAd Network Total Conversion Metrics[​**](#skad-network-total-conversion-metrics "Copy to clipboard")

The following metrics return the total sum of the SKAd Network SWIPE and VIEW conversions.

| Name                                                      | Description                                                                                                                                                                                    |
| --------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| conversion\_total\_installs\_sk\_ad\_network\_total       | Total App Installs tracked via SKAd Network                                                                                                                                                    |
| conversion\_ios\_installs\_sk\_ad\_network\_total         | Exact same metric as conversion\_total\_installs\_sk\_ad\_network\_total                                                                                                                       |
| conversion\_purchases\_sk\_ad\_network\_total             |                                                                                                                                                                                                |
| conversion\_save\_sk\_ad\_network\_total                  |                                                                                                                                                                                                |
| conversion\_start\_checkout\_sk\_ad\_network\_total       |                                                                                                                                                                                                |
| conversion\_add\_cart\_sk\_ad\_network\_total             |                                                                                                                                                                                                |
| conversion\_view\_content\_sk\_ad\_network\_total         |                                                                                                                                                                                                |
| conversion\_add\_billing\_sk\_ad\_network\_total          |                                                                                                                                                                                                |
| conversion\_sign\_ups\_sk\_ad\_network\_total             |                                                                                                                                                                                                |
| conversion\_searches\_sk\_ad\_network\_total              |                                                                                                                                                                                                |
| conversion\_level\_completes\_sk\_ad\_network\_total      |                                                                                                                                                                                                |
| conversion\_app\_opens\_sk\_ad\_network\_total            |                                                                                                                                                                                                |
| conversion\_page\_views\_sk\_ad\_network\_total           |                                                                                                                                                                                                |
| conversion\_subscribe\_sk\_ad\_network\_total             |                                                                                                                                                                                                |
| conversion\_ad\_click\_sk\_ad\_network\_total             |                                                                                                                                                                                                |
| conversion\_ad\_view\_sk\_ad\_network\_total              |                                                                                                                                                                                                |
| conversion\_complete\_tutorial\_sk\_ad\_network\_total    |                                                                                                                                                                                                |
| conversion\_invite\_sk\_ad\_network\_total                |                                                                                                                                                                                                |
| conversion\_login\_sk\_ad\_network\_total                 |                                                                                                                                                                                                |
| conversion\_share\_sk\_ad\_network\_total                 |                                                                                                                                                                                                |
| conversion\_reserve\_sk\_ad\_network\_total               |                                                                                                                                                                                                |
| conversion\_achievement\_unlocked\_sk\_ad\_network\_total |                                                                                                                                                                                                |
| conversion\_add\_to\_wishlist\_sk\_ad\_network\_total     |                                                                                                                                                                                                |
| conversion\_spend\_credits\_sk\_ad\_network\_total        |                                                                                                                                                                                                |
| conversion\_rate\_sk\_ad\_network\_total                  |                                                                                                                                                                                                |
| conversion\_start\_trial\_sk\_ad\_network\_total          |                                                                                                                                                                                                |
| conversion\_list\_view\_sk\_ad\_network\_total            |                                                                                                                                                                                                |
| conversion\_visitation\_sk\_ad\_network\_total            |                                                                                                                                                                                                |
| custom\_event\_1\_sk\_ad\_network\_total                  |                                                                                                                                                                                                |
| custom\_event\_2\_sk\_ad\_network\_total                  |                                                                                                                                                                                                |
| custom\_event\_3\_sk\_ad\_network\_total                  |                                                                                                                                                                                                |
| custom\_event\_4\_sk\_ad\_network\_total                  |                                                                                                                                                                                                |
| custom\_event\_5\_sk\_ad\_network\_total                  |                                                                                                                                                                                                |
| unknown\_sk\_ad\_network\_total                           | SkAdNetwork conversion events with unknown Conversion Values                                                                                                                                   |
| conversion\_assist\_install\_sk\_ad\_network\_total       | The number of times the SKAdNetwork campaign drove an App Install, but was not the last touch before the App Install occurred. conversion\_null\_sk\_ad\_network                               |
| conversion\_null\_sk\_ad\_network\_total                  | The number of SKAdNetwork conversion events with "null" Conversion Values. This indicates the campaign did not generate enough daily SKAdNetwork conversions to pass Apple’s privacy threshold |

## SKAd Network Conversion Example[​**](#skad-network-conversion-example "Copy to clipboard")

```
curl "https://adsapi.snapchat.com/v1/campaigns/5b483328-dfab-4321-be60-8ad2dfd63d35/stats?granularity=TOTAL&start_time=2021-01-21T00:00:00.000&end_time=2021-01-25T00:00:00.000&fields=impressions,spend,swipes,conversion_total_installs_sk_ad_network,conversion_purchases_sk_ad_network,conversion_add_cart_sk_ad_network"
  -H "Authorization: Bearer meowmeowmeow"
```

> The above command returns JSON structured like this:

```
{
  "request_status": "SUCCESS",
  "request_id": "601d83ee00ff06ea9762c9c4f20001737e616473617069736300016275696c642d31323762373738342d312d3432302d3000010161",
  "total_stats": [
    {
      "sub_request_status": "SUCCESS",
      "total_stat": {
        "id": "5b483328-dfab-4321-be60-8ad2dfd63d35",
        "type": "CAMPAIGN",
        "granularity": "TOTAL",
        "stats": {
          "impressions": 61295,
          "swipes": 4528,
          "spend": 407129814,
          "conversion_total_installs_sk_ad_network": 1199,
          "conversion_purchases_sk_ad_network": 6637,
          "conversion_add_cart_sk_ad_network": 7212
        },
        "start_time": "2021-01-20T16:00:00.000-08:00",
        "end_time": "2021-01-24T16:00:00.000-08:00",
        "finalized_data_end_time": "2021-02-05T03:00:00.000-08:00"
      }
    }
  ]
}
```

This example fetches three specific SKAd Network conversion metrics.

## Conversion Reporting[​**](#conversion-reporting "Copy to clipboard")

The **action\_report\_time** parameter specifies the timing to use when requesting conversion reporting. Passing the value **conversion** will return conversions based on the time the user triggered the conversion event, passing the value **impression** will return conversions based on the time the ad impression took place.

Reporting for conversions based on ad impression (action\_report\_time=impression), are available from 1st May 2020 onwards.

## Conversion Event Stats[​**](#conversion-event-stats "Copy to clipboard")

The following conversion event metrics are available for ads that have been setup to track conversions through [Snap Pixel](#snap-pixel).

| Fields                                   | Granularity | Description                                                                                            |
| ---------------------------------------- | ----------- | ------------------------------------------------------------------------------------------------------ |
| conversion\_purchases                    | Any         | # of attributed "PURCHASE" conversion events                                                           |
| conversion\_purchases\_value             | Any         | Value of attributed "PURCHASE" conversion events (microcurrency in Ad Account's currency)              |
| conversion\_save                         | Any         | # of attributed "SAVE" conversion events                                                               |
| conversion\_save\_value                  | Any         | Value of attributed "SAVE" conversion events (microcurrency in Ad Account's currency)                  |
| conversion\_start\_checkout              | Any         | # of attributed "START\_CHECKOUT" conversion events                                                    |
| conversion\_start\_checkout\_value       | Any         | Value of attributed "START\_CHECKOUT" conversion events (microcurrency in Ad Account's currency)       |
| conversion\_add\_cart                    | Any         | # of attributed "ADD\_CART" conversion events                                                          |
| conversion\_add\_cart\_value             | Any         | Value of attributed "ADD\_CART" conversion events (microcurrency in Ad Account's currency)             |
| conversion\_view\_content                | Any         | # of attributed "VIEW\_CONTENT" conversion events                                                      |
| conversion\_view\_content\_value         | Any         | Value of attributed "VIEW\_CONTENT" conversion events (microcurrency in Ad Account's currency)         |
| conversion\_add\_billing                 | Any         | # of attributed "ADD\_BILLING" conversion events                                                       |
| conversion\_add\_billing\_value          | Any         | Value of attributed "ADD\_BILLING" conversion events (microcurrency in Ad Account's currency)          |
| conversion\_sign\_ups                    | Any         | # of attributed "SIGN\_UP" conversion events                                                           |
| conversion\_sign\_ups\_value             | Any         | Value of attributed "SIGN\_UP" conversion events (microcurrency in Ad Account's currency)              |
| conversion\_searches                     | Any         | # of attributed "SEARCH" conversion events                                                             |
| conversion\_searches\_value              | Any         | Value of attributed "SEARCH" conversion events (microcurrency in Ad Account's currency)                |
| conversion\_level\_completes             | Any         | # of attributed "LEVEL\_COMPLETE" conversion events                                                    |
| conversion\_level\_completes\_value      | Any         | Value of attributed "LEVEL\_COMPLETE" conversion events (microcurrency in Ad Account's currency)       |
| conversion\_app\_opens                   | Any         | # of attributed "APP\_OPEN" conversion events                                                          |
| conversion\_app\_opens\_value            | Any         | Value of attributed "APP\_OPEN" conversion events (microcurrency in Ad Account's currency)             |
| conversion\_page\_views                  | Any         | # of attributed "PAGE\_VIEW" conversion events                                                         |
| conversion\_page\_views\_value           | Any         | Value of attributed "PAGE\_VIEW" conversion events (microcurrency in Ad Account's currency)            |
| conversion\_subscribe                    | Any         | # of attributed "SUBSCRIBE" conversion events                                                          |
| conversion\_subscribe\_value             | Any         | Value of attributed "SUBSCRIBE" conversion events (microcurrency in Ad Account's currency)             |
| conversion\_ad\_click                    | Any         | # of attributed "AD\_CLICK" conversion events                                                          |
| conversion\_ad\_click\_value             | Any         | Value of attributed "AD\_CLICK" conversion events (microcurrency in Ad Account's currency)             |
| conversion\_ad\_view                     | Any         | # of attributed "AD\_VIEW" conversion events                                                           |
| conversion\_ad\_view\_value              | Any         | Value of attributed "AD\_VIEW" conversion events (microcurrency in Ad Account's currency)              |
| conversion\_complete\_tutorial           | Any         | # of attributed "COMPLETE\_TUTORIAL" conversion events                                                 |
| conversion\_complete\_tutorial\_value    | Any         | Value of attributed "COMPLETE\_TUTORIAL" conversion events (microcurrency in Ad Account's currency)    |
| conversion\_invite                       | Any         | # of attributed "INVITE" conversion events                                                             |
| conversion\_invite\_value                | Any         | Value of attributed "INVITE" conversion events (microcurrency in Ad Account's currency)                |
| conversion\_login                        | Any         | # of attributed "LOGIN" conversion events                                                              |
| conversion\_login\_value                 | Any         | Value of attributed "LOGIN" conversion events (microcurrency in Ad Account's currency)                 |
| conversion\_share                        | Any         | # of attributed "SHARE" conversion events                                                              |
| conversion\_share\_value                 | Any         | Value of attributed "SHARE" conversion events (microcurrency in Ad Account's currency)                 |
| conversion\_reserve                      | Any         | # of attributed "RESERVE" conversion events                                                            |
| conversion\_reserve\_value               | Any         | Value of attributed "RESERVE" conversion events (microcurrency in Ad Account's currency)               |
| conversion\_achievement\_unlocked        | Any         | # of attributed "ACHIEVEMENT\_UNLOCKED" conversion events                                              |
| conversion\_achievement\_unlocked\_value | Any         | Value of attributed "ACHIEVEMENT\_UNLOCKED" conversion events (microcurrency in Ad Account's currency) |
| conversion\_add\_to\_wishlist            | Any         | # of attributed "ADD\_TO\_WISHLIST" conversion events                                                  |
| conversion\_add\_to\_wishlist\_value     | Any         | Value of attributed "ADD\_TO\_WISHLIST" conversion events (microcurrency in Ad Account's currency)     |
| conversion\_spend\_credits               | Any         | # of attributed "SPENT\_CREDITS" conversion events                                                     |
| conversion\_spend\_credits\_value        | Any         | Value of attributed "SPENT\_CREDITS" conversion events (microcurrency in Ad Account's currency)        |
| conversion\_rate                         | Any         | # of attributed "RATE" conversion events                                                               |
| conversion\_rate\_value                  | Any         | Value of attributed "RATE" conversion events (microcurrency in Ad Account's currency)                  |
| conversion\_start\_trial                 | Any         | # of attributed "START\_TRIAL" conversion events                                                       |
| conversion\_start\_trial\_value          | Any         | Value of attributed "START\_TRIAL" conversion events (microcurrency in Ad Account's currency)          |
| conversion\_list\_view                   | Any         | # of attributed "LIST\_VIEW" conversion events                                                         |
| conversion\_list\_view\_value            | Any         | Value of attributed "LIST\_VIEW" conversion events (microcurrency in Ad Account's currency)            |
| conversion\_visit                        | Any         | # of attributed "VISIT" conversion events                                                              |
| conversion\_visit\_value                 | Any         | Value of attributed "VISIT" conversion events (microcurrency in Ad Account's currency)                 |
| custom\_event\_1                         | Any         | # of attributed "CUSTOM\_EVENT\_1" conversion events                                                   |
| custom\_event\_1\_value                  | Any         | Value of attributed "CUSTOM\_EVENT\_1" conversion events (microcurrency in Ad Account's currency)      |
| custom\_event\_2                         | Any         | # of attributed "CUSTOM\_EVENT\_2" conversion events                                                   |
| custom\_event\_2\_value                  | Any         | Value of attributed "CUSTOM\_EVENT\_2" conversion events (microcurrency in Ad Account's currency)      |
| custom\_event\_3                         | Any         | # of attributed "CUSTOM\_EVENT\_3" conversion events                                                   |
| custom\_event\_3\_value                  | Any         | Value of attributed "CUSTOM\_EVENT\_3" conversion events (microcurrency in Ad Account's currency)      |
| custom\_event\_4                         | Any         | # of attributed "CUSTOM\_EVENT\_4" conversion events                                                   |
| custom\_event\_4\_value                  | Any         | Value of attributed "CUSTOM\_EVENT\_4" conversion events (microcurrency in Ad Account's currency)      |
| custom\_event\_5                         | Any         | # of attributed "CUSTOM\_EVENT\_5" conversion events                                                   |
| custom\_event\_5\_value                  | Any         | Value of attributed "CUSTOM\_EVENT\_5" conversion events (microcurrency in Ad Account's currency)      |

## Custom Conversions[​**](#custom-conversions "Copy to clipboard")

If you are using Custom Conversions, metrics are available using the conversion ID.

### Fetch Custom Conversion IDs[​**](#fetch-custom-conversion-ids "Copy to clipboard")

Custom conversions are created under the event source that they are reported via, for web events they will be created under the Pixel Entity. To fetch all custom conversions that have been defined under a specific pixel you should use this method.

**Pattern:**

```
GET /pixels/{pixel_id}/custom_conversions
```

### Reporting Restrictions[​**](#reporting-restrictions "Copy to clipboard")

Custom conversions can be requested at all levels (Ad Account, Campaign, Ad Set, Ad), with all parameters and granularities, with the exception of `report_dimension` (insights), the report\_dimension parameter cannot be used with custom conversions.

[...]
